/* header/twm.h

   This is the same header file for both twm.c and twmClient.c. However, the
   intuition include is not needed for twmClient, and can be omitted to
   reduce compilation time.
*/

#include <intuition/intuitionbase.h>
#include <exec/types.h>
#include <exec/memory.h>
#include <exec/ports.h>
#include <exec/lists.h>

#define PORTNAME ("TinyWindowManager")

#define GADGNAMESIZE   17

#define GADGHGUTTER        18
#define GADGVGUTTER        10
#define GADGWIDTH         (GADGNAMESIZE << 3)
#define GADGHEIGHT         10

/* commands passed in twm_action field of a twmMessage */
#define TWM_ACTION_ADD      0
#define TWM_ACTION_DELETE   1

/* return codes passed back in same field */
#define E_OK                0
#define E_OPEN_INTUI      501
#define E_ALREADY_UP      502
#define E_OPEN_PORT       503
#define E_OPEN_WINDOW     504
#define E_ACTION_UNKNOWN  505
#define E_TASK_UNKNOWN    506
#define E_NO_MEM          507
#define E_ABANDON_SHIP    508


struct twmMessage {
   struct Message tmMessage;     /* Exec message structure     */
   char *tmName;                 /* the client's gadget name   */
   int tmAction;                 /* add or delete gadget       */
};

struct twmGadget {
   struct Gadget      tgGadget;                 /* the gadget for a client */
   struct Border      tgBorder;                 /* box around gadget       */
   struct IntuiText   tgIText;                  /* text in gadget          */
   char               tgName[GADGNAMESIZE];     /* string for Intuitext    */
   struct twmMessage *tgMessage;                /* msg to reply on click   */
   struct twmGadget  *tgMynext;                 /* my link to next gadget  */
};
